#! /usr/local/bin/perl


#############################################################################
#  
#   GLOBAL VARIABLES 
#
#############################################################################

$mailprogram="/usr/lib/sendmail -t -n";

$signature="<font size=-1><i>Mehmet Sen </i></font>";

#############################################################################
#  
#   FIELDS OF A RECORD
#
#############################################################################

$filename="/servers/cgi-http-class/htdoc/users-docs/msen7/AcademicAffairs/remarks.html";
$verified=0;

@topics=("","New courses and programs","Changes in existing courses and programs","Degree requirements","Academic standards and criteria","Disciplinary procedures","");

#############################################################################
#  
#   MAIN FUNCTION   : main body
#
#############################################################################

&PrintHeader;                    # print HTML header
&openHtml;                       # prepare HTML file
&ReadEntry && &EXECUTE;          # read the input and process if it is valid
&closeHtml;                      # close the HTML file

#############################################################################
#  
#   Subroutine Readentry   : read the entry
#
#############################################################################

sub ReadEntry {             
   &ReadParse;                   # Read arguments passed from fill-out form

   $date = `date`;               # get the current date
   @default_dates = split( /\s+/ , $date);

# assign arguments to its values.
# if no from date is entered reservation is dome for the current day.

   $subject = ($in{'subject'}) ? $in{'subject'} : "No Subject";
   $email = ($in{'email'}) ? $in{'email'} : "";
   $from = ($in{'from'}) ? $in{'from'} : "";
   $topic = ($in{'topic'}) ? $in{'topic'} : 0; 
   $remarks = ($in{'remarks'}) ? $in{'remarks'} : "N/A";
  ## $topic=$topics[$topic];

   return 1;
}


#############################################################################
#  
#   Subroutine EXECUTION  : process the entry
#
#############################################################################

sub EXECUTE {
	#//if ($verified != 0)     # if there is no conflict
	#//   {
 	       print "<table bgcolor=yellow><tr><td><b> Thank you for your considiration</b></td></tr></table>";
	                        # print confirmation
                                # send e-mail about confirmation 
	#       open(MAIL, "|$mailprogram");
	#       print MAIL "From: $author\n";
	#       print MAIL "To: \<$email\>\n";
	#       print MAIL "Cc: $author\n";
	#       print MAIL "Subject: Your Remarks about Academic Affairs\n\n";
	#       print MAIL "Thank you very much for your participation\n";
	#       close(MAIL);	       
                               # record the entry into reservation file
	       &recordFile($filename);
	#//} else                 # if there is a conflict
	#//{
		                       # inform the user
	#//}
    }

#############################################################################
#  
#   Subroutine recordFile    : save the reservation data to the database
#
#############################################################################

sub recordFile {
    if ($from eq "" && $email eq "") {
	$sender="";
    }
    else {
    $sender="<tr><td>     <h3> FROM : $from  <a href=\"mailto:$email\">$email</h3>  	</td></tr>";}

    local($fn)=@_;
    open(OUT, ">> $fn");       # open the file for append 
    print OUT <<EOF;

<!-- start -->
    <table bgcolor="#ffcccc" border=8 width=100%><th align=left bgcolor=yellow ><h1> 
$subject 
    </h1></th><tr><td><h2> Topic: 
$topic 
    </h2> </td></tr>
$sender
    <tr><td>    
$remarks
    </td></tr></table><br>
<!-- end  -->

EOF
    close(OUT);
}

#############################################################################
#  
#   Subroutine scanFile: scan the file for conflicting reservations
#
#############################################################################

#############################################################################
#  
#   subroutines to prepare HTML document
#
#############################################################################

# Returns the magic line which tells WWW that this is an HTML document
sub PrintHeader {
  print "Content-type: text/html\n\n";
}

sub printFooter {
  print "$signature </body></html>\n";
}

sub openHtml {
print <<EOF;
<HTML>
<HEAD>
<title> </title>
</HEAD>
<body
background="" bgcolor=white>
<H1>Committee on Academic Affairs Student Remarks   
</h1>
EOF
}

sub closeHtml {
&printFooter;
print <<EOF;
</body>
</HTML>
EOF
}


##############################################################################
#
#  Get information from fill-out form.
#
##############################################################################


# reads the arguments passed from the form
sub ReadParse {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {                      # Read in text
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
        $in .=getc;
      }
  } else 
  {  # can be used for debugging on command line
      $in = <STDIN>;
      print "$in\n";
  }

    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
                                # Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
   }
   return 1; 
}
