#! /usr/local/bin/perl
#
# Ozgur Balsoy
# January 28, 1997
# v1.0
#
# Script for users to upload their links.
# + returns a link addition form if called with no parameter.
# + adds the suggested link if called w/ ?section=add (POST method used).
# + writes into $dataFile in the format "name,email,department,url".
# 
#
#############################################################################
#  
#   GLOBAL VARIABLES
#
#############################################################################

$Directory="http://osprey7.npac.syr.edu:3768/users-cgi/balsoy";
$addScript="$Directory/ecs400reg.pl";
$dataFile="/servers/cgi-http-class/htdoc/users-docs/balsoy/classlist.corrections";

$title="<header><title>ECS400 Home Page Registration</title></header>\n";
$signature="<hr><address><a href=http://www.cis.syr.edu/~balsoy>Ozgur Balsoy</a></address>\n";
$background="images/ecs400bg.gif";

#############################################################################
#  
#   MAIN FUNCTION
#
#############################################################################

&ReadEntry;
&printResults;

#############################################################################
#  
#   SUBROUTINES
#
#############################################################################

sub ReadEntry {
   &Parse(&Read);     # Read arguments passed from fill-out form
   return 1;
}


sub printResults {

&printHeader;

if ($in{"section"} eq "form") { &intro; }

elsif ($in{"section"} eq "add") {
      &addLink;
}

#  &Parse(&Read);
#  print join(" - ", %in);
#  return 1;

&printFooter;

}

##############################################################################
#
#  Get information from fill-out form.
#
##############################################################################


# Returns the magic line which tells WWW that this is an HTML document
sub printHeader {
  print "Content-type: text/html\n\n";
  print "<html> $title<body background=$background>";
}

sub printFooter {
  print "$signature </body></html>\n";
}

# reads the arguments passed from the form
sub Read {
    local ($i, $loc, $key, $val);

    if ($ENV{'REQUEST_METHOD'} eq "GET") {                      # Read in text
       $in = $ENV{'QUERY_STRING'};
    } elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
      for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
        $in .=getc;
      }
    }
    return $in;
}

sub Parse {
    $in = $_[0];
    local ($i, $loc, $key, $val);

    @in = split(/&/,$in);

    foreach $i (0 .. $#in) {
      $in[$i] =~ s/\+/ /g;                          # Convert plus's to spaces
      $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
                                # Convert %XX from hex numbers to alphanumeric
      $loc = index($in[$i], "=");                  # Split onto key and value.
      $key = substr($in[$i],0,$loc);
      $val = substr($in[$i],$loc+1);
#      $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
#      $in{$key} .= $val;
      $in{$key} = $val;
   }
   return 1; 
}


##############################################################################
#
#  Sub programs
#
##############################################################################

# Introduction
# Send a fill out form to find out whether to teach or browse.
sub intro {

@line=split(/%2A/, $in{"register"});
$line[0]=~ s/\+/ /g;
print "<h1>Information Verification Form</h1>\n";
print "<h2>Please enter missing information and correct typos.</h2><hr>";

print "<form method=post action=$addScript>\n";
print "<input type=hidden name=section value=add>\n";
print "<b>Your name</b><br>";
print "<input name=name size=50 value=\"$line[0]\"><br>\n"; 
print "<b>URL to your class page:</b><br>";
print "<input name=url size=50 value=\"$line[3]\"><br>\n";
print "<b>Email address:</b><br>";
print "<input name=email size=50 value=\"$line[1]\"><br>\n\n";
print "<b>Department:</b><br>";
print "<input name=dept size=50 value=\"$line[2]\"><br>\n\n";

print "<input TYPE =submit VALUE = Submit>";
print "<input type =reset  value = Clear>";
print "</form>\n";

}

sub addLink {

$lockfile="$dataFile.lock";
while (-e $lockfile) {} 
unless (symlink ($ENV{'REMOTE_ADDR'}, $lockfile)) {
    &errorUploads;
    return;
}

$date=`date`;
chop($date);
open(UPLOAD, ">>$dataFile");
print UPLOAD "$in{'name'},$in{'email'},$in{'dept'},$in{'url'}\n";
close(UPLOAD);
unlink($lockfile);

print "<h3>Thanks for your cooperation. The class list will be updated ";
print "later.</h3>";

}

sub errorUploads {

print "<h1>Error</h1>Could not add your link. Please go back, and try again!";

}

