#!/usr/npac/bin/perl -w
#
# File:  WriteFile.pl
#
# This script reads from standard input and writes to a file.
# The file must have world-write permission.
#
# Copyright:  Northeast Parallel Architectures Center

# File for writing:
$file = "WriteFile.txt";

# Note the else-block for command-line debugging:
if ( defined( $ENV{'REQUEST_METHOD'} ) ) {
  if ( $ENV{ 'REQUEST_METHOD' } eq "GET" ) {
    $in = $ENV{'QUERY_STRING'};
  } elsif ( $ENV{ 'REQUEST_METHOD' } eq "POST" ) {
    for ( $i = 0; $i < $ENV{ 'CONTENT_LENGTH' }; $i++ ) {
      $in .= getc;
    }
  } 
} else {
  print STDOUT "(enter text on standard input)\n";
  print STDOUT "(enter control-D when finished)\n";
  @lines = <STDIN>;  # remove newlines
  $in = join('', @lines);
}

print "Content-type: text/plain\n\n";
print "$in\n";

# Open file for output:
open( OUTFILE, ">$file") || ( print "Can't open $file\n" && die );

# Write data to file:
print OUTFILE "$in" || ( print "Can't write to $file\n" && die );

# Close the file:
close( OUTFILE ) || ( print "Can't close $file\n" && die );

print "OK\n";